%define oname crack

%define major 2
%define libname %mklibname %{oname} %{major}
%define devname %mklibname %{oname} -d

Summary:	A password-checking library
Name:		cracklib
Version:	2.9.6
Release:	3
License:	LGPLv2
Group:		System/Libraries
Url:		http://sourceforge.net/projects/cracklib/
Source0:	http://prdownloads.sourceforge.net/cracklib/cracklib-%{version}.tar.gz
Source1:	http://prdownloads.sourceforge.net/cracklib/cracklib-words.bz2
Source10:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/computer/Domains.bz2
Source11:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/computer/Dosref.bz2
Source12:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/computer/Ftpsites.bz2
Source13:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/computer/Jargon.bz2
Source14:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/computer/common-passwords.txt.bz2
Source15:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/computer/etc-hosts.bz2
Source16:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/movieTV/Movies.bz2
Source17:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/movieTV/Python.bz2
Source18:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/movieTV/Trek.bz2
Source19:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/literature/LCarrol.bz2
Source20:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/literature/Paradise.Lost.bz2
Source21:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/literature/cartoon.bz2
Source22:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/literature/myths-legends.bz2
Source23:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/literature/sf.bz2
Source24:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/literature/shakespeare.bz2
Source25:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/ASSurnames.bz2
Source26:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/Congress.bz2
Source27:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/Family-Names.bz2
Source28:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/Given-Names.bz2
Source29:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/famous.bz2
Source30:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/fast-names.bz2
Source31:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/female-names.bz2
Source32:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/male-names.bz2
Source33:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/names.french.bz2
Source34:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/names.hp.bz2
Source35:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/other-names.bz2
Source36:	ftp://ftp.cerias.purdue.edu/pub/dict/wordlists/names/surnames.finnish.bz2
Patch0:		cracklib-2.9.6-fix-python-path.patch
Patch1:		cracklib-2.9.1-inttypes.patch
Patch2:		cracklib-2.9.6-cve-2016-6318.patch
Patch3:		cracklib-2.9.5-overflow-processing-long-words.patch
Conflicts:	libcrack2 < 2.8.15
Conflicts:	lib64crack2 < 2.8.15
BuildRequires:	gettext-devel
BuildRequires:	pkgconfig(python)

%description
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics. You can use CrackLib to stop
users from choosing passwords which would be easy to guess. CrackLib
performs certain tests:

* It tries to generate words from a username and gecos entry and 
  checks those words against the password;
* It checks for simplistic patterns in passwords;
* It checks for the password in a dictionary.

CrackLib is actually a library containing a particular
C function which is used to check the password, as well as
other C functions. CrackLib is not a replacement for a passwd
program; it must be used in conjunction with an existing passwd
program.

Install the cracklib package if you need a program to check users'
passwords to see if they are at least minimally secure. If you
install CrackLib, you'll also want to install the cracklib-dicts
package.

#----------------------------------------------------------------------------

%package dicts
Summary:	The standard CrackLib dictionaries
Group:		System/Libraries

%description dicts
The cracklib-dicts package includes the CrackLib dictionaries.
CrackLib will need to use the dictionary appropriate to your system,
which is normally put in /usr/share/dict/words.  Cracklib-dicts also contains
the utilities necessary for the creation of new dictionaries.

If you are installing CrackLib, you should also install cracklib-dicts.

%files dicts
%{_sbindir}/*
%{_datadir}/%{name}
%{_libdir}/cracklib_dict.*

#----------------------------------------------------------------------------

%package common
Summary:	Common files for a password-checking library
Group:		System/Libraries
Conflicts:	cracklib < 2.8.18-12
Obsoletes:	cracklib < 2.8.18-12
Conflicts:	%{_lib}crack2 < 2.8.18-12

%description common
Common files for a password-checking library.

%files common -f %{name}.lang

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	A password-checking library
Group:		System/Libraries
Requires:	%{name}-common

%description -n %{libname}
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics.

%files -n %{libname}
/%{_lib}/libcrack.so.%{major}*

#----------------------------------------------------------------------------

%package -n python-%{name}
Summary:	A password-checking library
Group:		System/Libraries
Obsoletes:	cracklib-python < 2.8.18-12
Conflicts:	%{_lib}crack2-python < 2.8.18-12
Obsoletes:	%{_lib}crack2-python < 2.8.18-12

%description -n python-%{name}
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics.

%files -n python-%{name}
%{py_platsitedir}/cracklib*
%{py_platsitedir}/_cracklib*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Cracklib link library & header file
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	lib%{oname}-devel = %{EVRD}
Provides:	%{oname}lib-devel = %{EVRD}

%description -n %{devname}
The cracklib devel package include the needed library link and
header files for development.

%files -n %{devname}
%{_includedir}/*
/%{_lib}/*.so
/%{_lib}/*.*a

#----------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p1
cp -p lib/packer.h lib/packer.h.in
%patch1 -p1 -b .inttypes
%patch2 -p1 -b .CVE-2016-6318
%patch3 -p1 -b .overflow

for dict in %{SOURCE1} %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} \
    %{SOURCE15} %{SOURCE16} %{SOURCE17} %{SOURCE18} %{SOURCE19} %{SOURCE20} %{SOURCE21} \
    %{SOURCE22} %{SOURCE23} %{SOURCE24} %{SOURCE25} %{SOURCE26} %{SOURCE27} %{SOURCE28} \
    %{SOURCE29} %{SOURCE30} %{SOURCE31} %{SOURCE32} %{SOURCE33} %{SOURCE34} %{SOURCE35} \
    %{SOURCE36} %{SOURCE1}; do
    cp ${dict} dicts/
done
bunzip2 dicts/*.bz2

%build
autoreconf -fi
%configure2_5x \
	--libdir=/%{_lib}
%make

%install
%makeinstall_std

chmod 0755 ./util/cracklib-format ./util/cracklib-packer
./util/cracklib-format dicts/* | ./util/cracklib-packer %{buildroot}%{_datadir}/cracklib/pw_dict

ln -s cracklib-format %{buildroot}%{_sbindir}/mkdict
ln -s cracklib-packer %{buildroot}%{_sbindir}/packer

ln -s %{_datadir}/cracklib/pw_dict.hwm %{buildroot}%{_libdir}/cracklib_dict.hwm
ln -s %{_datadir}/cracklib/pw_dict.pwd %{buildroot}%{_libdir}/cracklib_dict.pwd
ln -s %{_datadir}/cracklib/pw_dict.pwi %{buildroot}%{_libdir}/cracklib_dict.pwi

install -m644 lib/packer.h %{buildroot}%{_includedir}/

%find_lang %{name}


%changelog

* Sun Feb 26 2017 Denis Silakov <denis.silakov@rosalab.ru> 2.9.6-3
- (606cb60) Fix buffer overflows


